#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys, os, shutil, sha, time

import pygtk
pygtk.require("2.0")

try :
	import gtk
	import gtk.glade
	import gobject
	import pango
	import gconf
except :
	print "you need to install python-gnome2 and pygtk and GTKv2."
	sys.exit(1)

import Options, TAB, WIDGET, Label, State, \
	Dialog, GConf, Conf, Menu, child, func

class main (WIDGET.WIDGET) :

	LIST_TAB = list()
	NOTEBOOK = None

	STATE = None
	IS_LOGO = True

	Toolbar = None
	Menubar = None

	ARGS_OPTIONS = dict()
	ARGS_ARGS = list()

	def __init__ (self, **kwargs) :

		# parse arguments and options.
		if kwargs.has_key("args_options") :
			self.ARGS_OPTIONS = kwargs["args_options"]

		if kwargs.has_key("args_args") :
			self.ARGS_ARGS = kwargs["args_args"]

		handler = { \
			# etc.
			"on_font_select" : self.on_fontSelectionDialog, \
			"on_insert_vim" : self.on_insert_vim, \
			"on_insert_gvim" : self.on_insert_gvim, \
			"on_remove_page" : self.on_remove_page, \
			"on_open_file_dialog" : self.on_fileSelectionDialog, \
			"on_font_increase" : self.on_font_increase, \
			"on_font_decrease" : self.on_font_decrease, \
			"on_next_tab" : self.on_next_tab, \
			"on_previous_tab" : self.on_previous_tab, \
			"on_toggle_toolbar" : self.on_toggle_toolbar, \
			"on_toggle_menubar" : self.on_toggle_menubar, \
			"on_insert_terminal" : self.on_insert_terminal, \
			"on_new_command" : self.on_new_command, \
			"on_preference" : self.on_preference, \
			"on_about" : self.on_about, \
			"on_quit_all" : self.on_ready_to_quit, \
		}

		WIDGET.WIDGET.__init__(self, "vee", None, handler)

		# create accelerator group.
		self.AccelGrpGlobal = gtk.AccelGroup()
		self.AccelGrpWhenHideMenubar = gtk.AccelGroup()

		# register global keyboard shortcut.
		self.WIDGET_SELF.add_accel_group(self.AccelGrpGlobal)
		self.__activate_accelerator( \
			self.AccelGrpGlobal, Conf.KEYBOARD_SHORTCUT_GLOBAL)

		self.STATE = State.State()

		# preference
		self.GCONF_CLIENT = GConf.Client()
		self.GCONF_CLIENT.add_dir(Conf.LOCAL_ROOT)

		gconf_notify = GConf.Notify(self.GCONF_CLIENT, state=self.STATE)
		gconf_notify.notify()

		self.GCONF_CLIENT.set_path(Conf.LOCAL_ROOT)

		# window size matters.
		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])

		__wh0 = [ int(i) for i in __wh.split(",")]

		self.WIDGET_SELF.set_default_size(__wh0[0], __wh0[1])
		self.WIDGET_SELF.resize(__wh0[0], __wh0[1])
		#self.WIDGET_SELF.move(__wh0[2], __wh0[3])

		self.WIDGET_SELF.connect( \
			"size_request", self.on_window_shape_changed)

		self.NOTEBOOK = self.xml.get_widget("notebook1")
		self.NOTEBOOK.remove_page(0)
		self.NOTEBOOK.popup_disable()
		self.NOTEBOOK.connect( \
			"button-press-event", Menu.on_show_popup_TAB, self.STATE)

		# store information into state
		self.STATE.set_value("root-widget", self.WIDGET_SELF)
		self.STATE.set_value("notebook", self.NOTEBOOK)
		self.STATE.set_value("tab-list", self.LIST_TAB)

		# status bar.
		STATUSBAR = Label.Statusbar(self.xml.get_widget("statusbar1"))
		self.STATE.set_value("statusbar", STATUSBAR)

		# set event.
		EB = self.xml.get_widget("eventbox1")
		EB.connect("event", self.on_set_background_logo)

		# toolbar and menubar
		self.Toolbar = self.xml.get_widget("toolbar1")

		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-toolbar"]["key"]) :
			self.Toolbar.hide()

		self.Menubar = self.xml.get_widget("hbox1")
		self.Menubar.connect( \
			"hide", self.on_activate_accelerator_when_hide_menubar)
		self.Menubar.connect( \
			"show", self.deactivate_accelerator_when_hide_menubar)

		if not self.GCONF_CLIENT.get_value(Conf.SCHEMA["show-menubar"]["key"]) :
			self.Menubar.hide()

		self.STATE.set_value("toolbar", self.Toolbar)
		self.STATE.set_value("menubar", self.Menubar)

		print "==========================================="
		print " Launched."
		print ""

		if len(self.ARGS_ARGS) > 0 :
			for i in self.ARGS_ARGS :
				self.addPage("vim", filename=i)
		else :
			if self.ARGS_OPTIONS.ARG_START_WITH_VIM : self.addPage("vim")
			if self.ARGS_OPTIONS.ARG_START_WITH_TERMINAL : self.addPage("terminal")

		if not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR : self.Toolbar.hide()
		if not self.ARGS_OPTIONS.ARG_SHOW_MENUBAR : self.Menubar.hide()

		# activate dnd.
		self.NOTEBOOK.connect( \
			"drag_data_received", self.on_drag_received)

		self.Menubar.connect( \
			"drag_data_received", self.on_drag_received)

		self.Toolbar.connect( \
			"drag_data_received", self.on_drag_received)

		self.NOTEBOOK.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Menubar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		self.Toolbar.drag_dest_set( \
			gtk.DEST_DEFAULT_MOTION |
			gtk.DEST_DEFAULT_HIGHLIGHT |
			gtk.DEST_DEFAULT_DROP,
			Conf.DND_TARGET_TABLE, gtk.gdk.ACTION_COPY)

		# test ##################################################
		#self.addPage("gvim")
		#self.addExample()

	# EVENT HANDLER #####################################################
	def on_drag_received \
			(self, widget, context, x, y, selection, targetType, time) :

		__path = func.get_filename_from_uri(selection.data)
		self.addPage("vim", filename=__path)

	def on_ready_to_quit (self, parm1, parm2=None) :

		if type(self.IS_LOGO) is int :
			gtk.main_quit()
		else :
			Dialog.AskCloseAllTabDialog(self.WIDGET_SELF, self.STATE)

		return True

	def on_new_command (self, widget) :
		__c = widget.get_text()
		if len(__c.strip()) < 1 : return

		parsed_argv = func.parse_command_line_argument(__c)

		self.addPage("external_command", **parsed_argv)

	def on_window_shape_changed (self, widget, parm1) :

		__wh = self.GCONF_CLIENT.get_value( \
			Conf.SCHEMA["latest-window-geometry"]["key"])
		__wh0 = [ int(i) for i in __wh.split(",")]

		(w, h) = self.WIDGET_SELF.get_size()

		self.GCONF_CLIENT.set_value( \
			"string", Conf.SCHEMA["latest-window-geometry"]["key"], \
			"%d,%d,%d,%d" % (w, h, __wh0[2], __wh0[3]) \
		)

	def on_toggle_menubar (self, widget) :
		if self.Menubar.get_property("visible") :
			self.Menubar.hide()
		else :
			self.Menubar.show()

	def on_toggle_toolbar (self, widget) :
		if self.Toolbar.get_property("visible") :
			self.Toolbar.hide()
		else :
			self.Toolbar.show()

	def on_set_background_logo (self, parm1, parm2) :

		if self.NOTEBOOK.get_n_pages() < 1 :
			self.addLogo()

	#############################################################
	# EVENT HANDLER
	def on_fileSelectionDialog (self, widget) :
		Dialog.FileSelectionDialog(self)

	def on_fontSelectionDialog (self, widget) :
		Dialog.FontSelectionDialog( \
			self.xml, self.LIST_TAB[self.NOTEBOOK.get_current_page()])

	def on_preference (self, widget) :
		Dialog.Preference()

	def on_about (self, widget) :
		Dialog.About()

	def on_insert_gvim (self, widget) :
		self.addPage("gvim")

	def on_insert_vim (self, widget) :
		self.addPage("vim")

	def on_insert_terminal (self, widget) :
		self.addPage("terminal")

	def on_remove_page (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()
		tab = self.LIST_TAB[current_page]
		tab.Child.exit()
		STATUSBAR.clean()

	def on_font_decrease (self, widget) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def on_font_increase (self, widget) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def on_next_tab (self, widget) :
		self.NOTEBOOK.next_page()

	def on_previous_tab (self, widget) :
		self.NOTEBOOK.prev_page()

	def on_change_title (self, widget) :
		current_page = self.NOTEBOOK.get_current_page()

		__title = self.LIST_TAB[current_page].Child.get_title()

		self.set_title(__title)
		self.LIST_TAB[current_page].INSTANCE_LABEL.set_label(__title)

	def set_title (self, strings) :
		self.WIDGET_SELF.set_title("%s : VEE" % strings)

	#------------------------------------------------------------
	# Accel HANDLER
	def ac_font_decrease (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.decrease_font()

	def ac_font_increase (self, parm1, parm2, parm3, parm4) :
		try :
			tab = self.LIST_TAB[self.NOTEBOOK.get_current_page()]
		except :
			return

		tab.Child.increase_font()

	def ac_insert_gvim (self, parm1, parm2, parm3, parm4) :
		self.addPage("gvim")

	def ac_insert_vim (self, parm1, parm2, parm3, parm4) :
		self.addPage("vim")

	def ac_insert_terminal (self, parm1, parm2, parm3, parm4) :
		self.addPage("terminal")

	def ac_fileSelectionDialog  (self, parm1, parm2, parm3, parm4) :
		Dialog.FileSelectionDialog(self)

	def ac_next_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_previous_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.prev_page()

	def ac_rotate_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_focus_on_external_command (self, parm1, parm2, parm3, parm4) :
		__entry = self.xml.get_widget("entry15")
		__entry.grab_focus()

	#############################################################
	# etc method.
	def __activate_accelerator (self, accel_group, shortcut_tuple=tuple()) :
		if len(shortcut_tuple) < 1 : return False

		for i in shortcut_tuple :
			__o = Conf.LIST_KEYBOARD_SHORTCUT[i]

			if len(__o) < 2 : continue

			__key = gtk.accelerator_parse(__o[0])
			accel_group.connect_group(__key[0], __key[1], \
				gtk.ACCEL_VISIBLE, eval(__o[1]))

		return True

	def on_activate_accelerator_when_hide_menubar (self, parm1) :
		self.WIDGET_SELF.add_accel_group(self.AccelGrpWhenHideMenubar)

		self.__activate_accelerator( \
			self.AccelGrpWhenHideMenubar, \
			Conf.KEYBOARD_SHORTCUT_WHEN_HIDE_MENUBAR)

	def deactivate_accelerator_when_hide_menubar (self, parm1) :
		self.WIDGET_SELF.remove_accel_group(self.AccelGrpWhenHideMenubar)

	def activate_accelerator1 (self, parm1) :
		# set accelerator

		__key = gtk.accelerator_parse("<Control>Page_Up")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_next_tab)

		__key = gtk.accelerator_parse("<Control>Page_Down")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_previous_tab)

		__key = gtk.accelerator_parse("<Control>equal")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_font_increase)

		__key = gtk.accelerator_parse("<Control>minus")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_font_decrease)

		__key = gtk.accelerator_parse("<Control><Shift>G")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_insert_gvim)

		__key = gtk.accelerator_parse("<Control><Shift>V")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_insert_vim)

		__key = gtk.accelerator_parse("<Control><Shift>O")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_fileSelectionDialog)

		__key = gtk.accelerator_parse("<Control><Shift>Z")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_insert_terminal)

		__key = gtk.accelerator_parse("<Control>Q")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, gtk.main_quit)

		__key = gtk.accelerator_parse("<Control>L")
		self.AccelGrp.connect_group(__key[0], __key[1], \
			gtk.ACCEL_VISIBLE, self.ac_focus_on_external_command)

	def on_test (self, obj, parm1) :
		print obj
		print parm1

	def addLogo (self) :
		Logo = gtk.Image()
		Logo.set_from_file(os.path.join(sys.path[0], "vee-1.1.png"))
		Logo.show()

		#self.NOTEBOOK.append_page(Logo)
		tab = TAB.TAB( \
			state=self.STATE, \
			without_closebutton=True)

		tab.addWidget(Logo, "브이 VEE")

		self.IS_LOGO = self.NOTEBOOK.get_current_page()
		self.STATE.set_value("is-logo", self.IS_LOGO)

	def addPage (self, childname, **kwargs) :
		if type(self.IS_LOGO) is int :
			self.NOTEBOOK.remove_page(self.IS_LOGO)
			self.IS_LOGO = False

		__tab = child.getTab(childname)
		tab = __tab(self.STATE, **kwargs)

		tab.make()

	def addExample (self) :

		if type(self.IS_LOGO) is int :
			self.NOTEBOOK.remove_page(self.IS_LOGO)
			self.IS_LOGO = False

		__example = child.getChild("example")
		example = __example()
		example.make()

		tab = TAB.TAB(state=self.STATE)
		tab.STR_TAB_NAME = "Example"
		tab.addVTE(example)

		self.LIST_TAB.append(tab)

		# set window title
		#self.set_title(tab.INSTANCE_LABEL.get_label())

		example.WIDGET.connect("window-title-changed", self.on_change_title)

if __name__ == "__main__" :

	# parse command-line argument.
	(__OPTIONS, __ARGS) = Options.parseOptions()

	# check whether the gconf schema was installed, if not install it.
	Conf.verify()

	app = main(args_options=__OPTIONS, args_args=__ARGS)

	try :
		gtk.main()
	except :
		sys.exit(1)
	else :
		sys.exit(0)

